
From: William Lee Irwin III <wli@holomorphy.com>

As ->vm_private_data is used as a cursor for swapout of VM_NONLINEAR vmas,
the check for NULL ->vm_private_data or VM_RESERVED is too strict, and
should allow VM_NONLINEAR vmas with non-NULL ->vm_private_data.

This fixes an issue on 2.6.7-mm5 where system calls to remap_file_pages()
spuriously failed while under memory pressure.

Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 25-akpm/mm/fremap.c |    3 ++-
 1 files changed, 2 insertions(+), 1 deletion(-)

diff -puN mm/fremap.c~spurious-remap_file_pages-einval mm/fremap.c
--- 25/mm/fremap.c~spurious-remap_file_pages-einval	2004-07-04 21:36:10.652411680 -0700
+++ 25-akpm/mm/fremap.c	2004-07-04 21:36:10.656411072 -0700
@@ -194,7 +194,8 @@ asmlinkage long sys_remap_file_pages(uns
 	 * or VM_LOCKED, but VM_LOCKED could be revoked later on).
 	 */
 	if (vma && (vma->vm_flags & VM_SHARED) &&
-		(!vma->vm_private_data || (vma->vm_flags & VM_RESERVED)) &&
+		(!vma->vm_private_data ||
+			(vma->vm_flags & (VM_NONLINEAR|VM_RESERVED))) &&
 		vma->vm_ops && vma->vm_ops->populate &&
 			end > start && start >= vma->vm_start &&
 				end <= vma->vm_end) {
_
